## blacs-pvm 1.1

=== INSTALL/Makefile ===
include ../Bmake.inc

help :
	@ echo " "
	@ echo " "
	@ echo "You need to specify which INSTALL executable to build."
	@ echo "General choices are: xsize, xintface, xsyserrors"
	@ echo "MPI specific choices are: xsyserrors, xtc_CsameF77, xtc_UseMpich,"
	@ echo "                          xcmpi_sane, xfmpi_sane"
	@ echo " "
	@ echo "Here is a brief explanation of each of these routines: "
	cat README

xsize : $(INSTdir)/xsize
xintface : $(INSTdir)/xintface
xsyserrors : $(INSTdir)/xsyserrors
xcmpi_sane : $(INSTdir)/xcmpi_sane
xfmpi_sane : $(INSTdir)/xfmpi_sane
xtc_CsameF77 : $(INSTdir)/xtc_CsameF77
xtc_UseMpich : $(INSTdir)/xtc_UseMpich

$(INSTdir)/xsize : size.o
	$(CCLOADER) $(CCLOADFLAGS) -o $@ size.o

$(INSTdir)/xintface : Fintface.o Cintface.o
	$(F77LOADER) $(F77LOADFLAGS) -o $@ Fintface.o Cintface.o

$(INSTdir)/xsyserrors : syserrors.o
	$(CCLOADER) $(CCLOADFLAGS) -o $@ syserrors.o $(MPILIB)

$(INSTdir)/xtc_CsameF77 : mpif.h tc_fCsameF77.o tc_cCsameF77.o
	$(F77LOADER) $(F77LOADFLAGS) -o $@ tc_fCsameF77.o tc_cCsameF77.o $(MPILIB)

$(INSTdir)/xtc_UseMpich : tc_UseMpich.o
	$(CCLOADER) $(CCLOADFLAGS) -o $@ tc_UseMpich.o $(MPILIB)

$(INSTdir)/xcmpi_sane : cmpi_sane.o
	$(CCLOADER) $(CCLOADFLAGS) -o $@ cmpi_sane.o $(MPILIB)

$(INSTdir)/xfmpi_sane : mpif.h fmpi_sane.o
	$(F77LOADER) $(F77LOADFLAGS) -o $@ fmpi_sane.o $(MPILIB)

clean:
	rm -f size.o Fintface.o Cintface.o syserrors.o transcomm.o \
              mpi_sane.o fmpi_sane.o

mpif.h : $(MPIINCdir)/mpif.h
	rm -f mpif.h
	ln -s $(MPIINCdir)/mpif.h mpif.h

.f.o: ; $(F77) -c $(F77FLAGS) $*.f
.c.o:
	$(CC) -c $(CCFLAGS) $(BLACSDEFS) $<

=== SRC/PVM/Makefile ===
dlvl = ../..
include $(dlvl)/Bmake.inc

#  --------------------------
#  The communication routines
#  --------------------------
comm = igesd2d_.o sgesd2d_.o dgesd2d_.o cgesd2d_.o zgesd2d_.o \
       itrsd2d_.o strsd2d_.o dtrsd2d_.o ctrsd2d_.o ztrsd2d_.o \
       igerv2d_.o sgerv2d_.o dgerv2d_.o cgerv2d_.o zgerv2d_.o \
       itrrv2d_.o strrv2d_.o dtrrv2d_.o ctrrv2d_.o ztrrv2d_.o \
       igebs2d_.o sgebs2d_.o dgebs2d_.o cgebs2d_.o zgebs2d_.o \
       igebr2d_.o sgebr2d_.o dgebr2d_.o cgebr2d_.o zgebr2d_.o \
       itrbs2d_.o strbs2d_.o dtrbs2d_.o ctrbs2d_.o ztrbs2d_.o \
       itrbr2d_.o strbr2d_.o dtrbr2d_.o ctrbr2d_.o ztrbr2d_.o \
       igsum2d_.o sgsum2d_.o dgsum2d_.o cgsum2d_.o zgsum2d_.o \
       igamx2d_.o sgamx2d_.o dgamx2d_.o cgamx2d_.o zgamx2d_.o \
       igamn2d_.o sgamn2d_.o dgamn2d_.o cgamn2d_.o zgamn2d_.o

#  -----------------------------------------------------------------------------
#  These names are too long for the archiver to distinguish based on the suffix.
#  I'm going to use logical links to get around this problem.  It's hokey, but
#  it lets us use the suffix rule and keep the makefile portable.
#  -----------------------------------------------------------------------------
long = blacs_gridinit_.o blacs_gridmap_.o blacs_freebuff_.o \
       blacs_gridexit_.o blacs_gridinfo_.o blacs_barrier_.o

Clong = Cblacs_gridinit_.C Cblacs_gridmap_.C Cblacs_freebuff_.C \
        Cblacs_gridexit_.C Cblacs_gridinfo_.C Cblacs_barrier_.C

#  --------------------
#  The support routines
#  --------------------
supp = blacs_pinfo_.o blacs_setup_.o blacs_set_.o blacs_get_.o \
       blacs_abort_.o blacs_exit_.o blacs_pnum_.o blacs_pcoord_.o \
       ksendid_.o krecvid_.o kbsid_.o kbrid_.o \
       setpvmtids_.o dcputime00_.o dwalltime00_.o

#  ----------------------------
#  The fortran and C interfaces
#  ----------------------------
Fintobj   = $(comm) $(supp) $(long)
Cintobj   = $(comm:.o=.C) $(supp:.o=.C) $(Clong)

#  ---------------------
#  The internal routines
#  ---------------------
internal = GlobalVars.o \
           Shyp_bs.o Shyp_br.o Sidring_bs.o Sidring_br.o \
           Smpath_bs.o Smpath_br.o Ssring_bs.o Ssring_br.o \
           Stree_bs.o Stree_br.o  tree_comb.o BE_comb.o \
           Ssend2d00.o Ssend2dID.o Srecv2d00.o Srecv2dID.o \
           ArgCheck00.o getbuff.o TransDist.o RepTreeComb.o \
           BlacsErr.o BlacsWarn.o BlacsAbort00.o \
           ipack00.o iunpack00.o itrpack00.o itrunpack00.o \
           spack00.o sunpack00.o strpack00.o strunpack00.o \
           dpack00.o dunpack00.o dtrpack00.o dtrunpack00.o \
           cpack00.o cunpack00.o ctrpack00.o ctrunpack00.o \
           zpack00.o zunpack00.o ztrpack00.o ztrunpack00.o \
           igpk4op.o igupk4op.o igupk_sum.o \
           igpk4amxamn.o igupk4amxamn.o igupk_amx.o igupk_amx2.o \
           igupk_amn.o igupk_amn2.o \
           sgpk4op.o sgupk4op.o sgupk_sum.o \
           sgpk4amxamn.o sgupk4amxamn.o sgupk_amx.o sgupk_amx2.o \
           sgupk_amn.o sgupk_amn2.o \
           dgpk4op.o dgupk4op.o dgupk_sum.o \
           dgpk4amxamn.o dgupk4amxamn.o dgupk_amx.o dgupk_amx2.o \
           dgupk_amn.o dgupk_amn2.o \
           cgpk4op.o cgupk4op.o cgupk_sum.o \
           cgpk4amxamn.o cgupk4amxamn.o cgupk_amx.o cgupk_amx2.o \
           cgupk_amn.o cgupk_amn2.o \
           zgpk4op.o zgupk4op.o zgupk_sum.o \
           zgpk4amxamn.o zgupk4amxamn.o zgupk_amx.o zgupk_amx2.o \
           zgupk_amn.o zgupk_amn2.o

lib : all
f77lib : flib
F77lib : flib
Clib : clib

#  ---------------------------------------
#  Make both C and fortran interface BLACS
#  ---------------------------------------
all : INTERN $(Fintobj) $(Cintobj)
	$(ARCH) $(ARCHFLAGS) $(BLACSLIB) $(Fintobj) $(Cintobj)
	$(RANLIB) $(BLACSLIB)

#  -------------------------------------
#  Make only the fortran interface BLACS
#  -------------------------------------
flib : $(Fintobj)
	( cd INTERNAL ; rm -f $(internal) )
	$(MAKE) INTERN
	$(ARCH) $(ARCHFLAGS) $(BLACSLIB) $(Fintobj)
	$(RANLIB) $(BLACSLIB)

#  -------------------------------
#  Make only the C interface BLACS
#  -------------------------------
clib : $(Cintobj)
	( cd INTERNAL ; rm -f $(internal) )
	$(MAKE) INTERN
	$(ARCH) $(ARCHFLAGS) $(BLACSLIB) $(Cintobj)
	$(RANLIB) $(BLACSLIB)

#  ------------------
#  Make the internals
#  ------------------
INTERN :
	( cd INTERNAL ; $(MAKE) -f ../Makefile I_int "dlvl=$(BTOPdir)" )

I_int : Bconfig.h Bdef.h $(internal)
	$(ARCH) $(ARCHFLAGS) $(BLACSLIB) $(internal)

Bdef.h : ../Bdef.h
	rm -f Bdef.h
	ln -s ../Bdef.h Bdef.h

Bconfig.h : ../Bconfig.h
	rm -f Bconfig.h
	ln -s ../Bconfig.h Bconfig.h

#  -----------------------
#  Delete the object files
#  -----------------------
clean :
	rm -f $(Cintobj) $(Fintobj) $(long:.o=.C)
	( cd INTERNAL ; rm -f $(internal) )

#  -------------------------------------
#  Delete the library, object and source
#  -------------------------------------
killib :
	$(MAKE) clean
	rm -f $(Fintobj:.o=.c) Bdef.h Bconfig.h
	( cd INTERNAL ; rm -f $(internal:.o=.c) Bdef.h Bconfig.h )

#  -------------------------------------------------------------------------
#  Establish how to make logical links to the long-name C interface routines
#  that are distinct in first 13 characters from their Fortran interface 
#  equivalents.
#  -------------------------------------------------------------------------
Cblacs_gridinit_.C : blacs_gridinit_.C
	ln -s blacs_gridinit_.C Cblacs_gridinit_.C
Cblacs_gridinfo_.C : blacs_gridinfo_.C
	ln -s blacs_gridinfo_.C Cblacs_gridinfo_.C
Cblacs_gridexit_.C : blacs_gridexit_.C
	ln -s blacs_gridexit_.C Cblacs_gridexit_.C
Cblacs_gridmap_.C : blacs_gridmap_.C
	ln -s blacs_gridmap_.C Cblacs_gridmap_.C
Cblacs_freebuff_.C : blacs_freebuff_.C
	ln -s blacs_freebuff_.C Cblacs_freebuff_.C
Cblacs_barrier_.C : blacs_barrier_.C
	ln -s blacs_barrier_.C Cblacs_barrier_.C

#  ------------------------------------------------------------------------
#  We move C .o files to .C so that we can use the portable suffix rule for
#  compilation, and still have them coexist with the fortran interface
#  .o files.
#  ------------------------------------------------------------------------
.SUFFIXES: .o .C
.c.C:
	$(CC) -o C$*.o -c $(CCFLAGS) $(BLACSDEFS) -DCallFromC $<
	mv C$*.o $*.C
.c.o:
	$(CC) -c $(CCFLAGS) $(BLACSDEFS) $<

=== debian/changelog ===
blacs-pvm (1.1-21) unstable; urgency=low

  * Bumped standards version to 3.9.2. No changes were needed. 
  * Switch to dpkg-source 3.0 (quilt) format.
  * Maintainer's mail has been changed.

 -- Muammar El Khatib <muammar@debian.org>  Sun, 28 Aug 2011 21:11:26 +0200

blacs-pvm (1.1-20) unstable; urgency=low

  * Bumped standards version to 3.8.4. No changes were needed. 
  * debian/control: blacs-pvm-test was depending on a non existent package 
    (blacsgf-test-common). Such an error has been corrected updating the Depends
    field with the name of the existent package, in this case blacs-test-common.

 -- Muammar El Khatib <muammarelkhatib@gmail.com>  Wed, 31 Mar 2010 20:16:19 -0430

blacs-pvm (1.1-19) unstable; urgency=low

  * Bug: 'blacs-pvm-test depends on obsolete blacs-test-common' has been fixed
    in this revision. (Closes: #473740)
  * Copyright file has been fixed. So there is no lintian's complains about
    that.

 -- Muammar El Khatib <muammarelkhatib@gmail.com>  Fri, 04 Apr 2008 00:59:29 -0430

blacs-pvm (1.1-18) unstable; urgency=low

  * Bumped standards version to 3.7.3
  * debian/compat file was created.
  * Webpage was moved from blacs-pvm's description to control tag.
  * The package is now built using gfortran instead of g77. Thanks to Colin
    Tuckley for providing patches and helping.(Closes: #459589)

 -- Muammar El Khatib <muammarelkhatib@gmail.com>  Wed, 09 Jan 2008 00:00:30 -0430

blacs-pvm (1.1-17) unstable; urgency=low

  * Bumped standards version to 3.7.2
  * New maintainer. Closes: #335009
  * Updated build dependency to debhelper >= 5.
  * The watch file was added. Thanks to James Westby.
  * The use of ${Source-Version} was dropped.
  * Added another space in front of Homepage in control. (Philipp Frauenfelder)

 -- Muammar El Khatib <muammarelkhatib@gmail.com>  Sun,  3 Sep 2006 23:41:28 +0000

blacs-pvm (1.1-16) unstable; urgency=low

  * Bumped standards version to 3.6.1
  * Changed documentation to comply with MPICH and LAM packages.

 -- Philipp Frauenfelder <pfrauenf@debian.org>  Wed, 17 Sep 2003 14:23:15 +0200

blacs-pvm (1.1-15) unstable; urgency=low

  * Added -ffunction-sections to F77 as well. Closes: #127227

 -- Philipp Frauenfelder <pfrauenf@debian.org>  Sun, 13 Jan 2002 09:54:25 +0100

blacs-pvm (1.1-14) unstable; urgency=low

  * Moved -ffunction-sections from CCFLAGS to CC. Not all C files are
    compiled with CCFLAGS. Closes: #127227

 -- Philipp Frauenfelder <pfrauenf@debian.org>  Sat,  5 Jan 2002 16:52:12 +0100

blacs-pvm (1.1-13) unstable; urgency=low

  * Added -ffunction-sections to CCFLAGS. Should make this package
    compile on hppa as well. Closes: #127227

 -- Philipp Frauenfelder <pfrauenf@debian.org>  Tue,  1 Jan 2002 12:53:27 +0100

blacs-pvm (1.1-12) unstable; urgency=low

  * Typo in debian/control. Closes: #124458

 -- Philipp Frauenfelder <pfrauenf@debian.org>  Sun, 23 Dec 2001 15:59:53 +0100

blacs-pvm (1.1-11) unstable; urgency=low

  * Made sure -fPIC is used for all compilations in the shared library
    case (was not before!). Closes: #108249

 -- Philipp Frauenfelder <pfrauenf@debian.org>  Fri, 10 Aug 2001 11:25:51 +0000

blacs-pvm (1.1-10) unstable; urgency=low

  * Changed section of blacs1-pvm from devel to libs and added some
    more sensible depends.

 -- Philipp Frauenfelder <pfrauenf@debian.org>  Fri,  3 Aug 2001 15:42:28 +0000

blacs-pvm (1.1-9) unstable; urgency=low

  * Added Build-Depends to pvm-dev. Closes: #70933

 -- Philipp Frauenfelder <pfrauenf@debian.org>  Wed,  6 Sep 2000 09:55:40 +0200

blacs-pvm (1.1-8) unstable; urgency=low

  * New standards version: 3.2.1
  * Build-Depends. Closes: #70178

 -- Philipp Frauenfelder <pfrauenf@debian.org>  Mon,  4 Sep 2000 15:53:30 +0200

blacs-pvm (1.1-7) frozen; urgency=low

  * Recompiling on potato.

 -- Philipp Frauenfelder <pfrauenf@debian.org>  Sat, 22 Apr 2000 16:42:31 +0200

blacs-pvm (1.1-6) unstable; urgency=low

  * Moved creation of TESTING/EXE to build targets in debian/rules.
    Closes: #51631.

 -- Philipp Frauenfelder <pfrauenf@debian.org>  Tue, 30 Nov 1999 16:44:18 +0100

blacs-pvm (1.1-5) unstable; urgency=low

  * Add TESTING/EXE directory if it does not exist in rules.

 -- Philipp Frauenfelder <pfrauenf@debian.org>  Thu, 18 Nov 1999 13:56:15 +0100

blacs-pvm (1.1-4) unstable; urgency=low

  * Changed build process to get shared libraries too. Inspired by
    Camm Maguire <camm@enhanced.com>. New packages: blacs1-pvm,
    blacs-pvm-dev, blacs-test-pvm. Obsolete: blacs-pvm.

 -- Philipp Frauenfelder <pfrauenf@debian.org>  Wed,  3 Nov 1999 14:47:00 +0100

blacs-pvm (1.1-3) unstable; urgency=low

  * Changed priority from optional to extra to fix dependency bug.
  * Bumped standards version to 3.0.1.
  * Moved to debhelper v2.

 -- Philipp Frauenfelder <pfrauenf@debian.org>  Thu, 19 Aug 1999 11:44:36 +0200

blacs-pvm (1.1-2) unstable; urgency=low

  * Changed path in Bmake.inc, closes #37402 (which was against
    blacs-mpi but applies for blacs-pvm too)
  * Changed binary-arch and binary-indep in debian/rules, closes #37403

 -- Philipp Frauenfelder <pfrauenf@debian.org>  Mon, 10 May 1999 23:52:04 +0200

blacs-pvm (1.1-1) unstable; urgency=low

  * Initial release.

 -- Philipp Frauenfelder <pfrauenf@debian.org>  Sat, 24 Apr 1999 11:29:51 +0200

=== debian/control ===
Source: blacs-pvm
Section: devel
Priority: extra
Maintainer: Muammar El Khatib <muammar@debian.org>
Standards-Version: 3.9.2
Build-Depends: debhelper (>= 5), gfortran, pvm-dev, quilt
Homepage: http://www.netlib.org/blacs/

Package: blacs-pvm-dev
Architecture: any
Depends: blacs1-pvm (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: scalapack-doc
Replaces: blacs-pvm
Conflicts: blacs-pvm
Description: Basic Linear Algebra Comm. Subprograms - Dev. files for PVM
 The BLACS project is an ongoing investigation whose purpose is to
 create a linear algebra oriented message passing interface that may be
 implemented efficiently and uniformly across a large range of
 distributed memory platforms.
 .
 You can choose between an implementation based on MPI or PVM. This
 package uses PVM.
 .
 There are packages for the shared libraries, for the static libraries
 and the development files (this one) and for test programs.
 .
 Most users do not need to install this package directly because it is
 used as a high level driver for the communication in the ScaLAPACK packages.
 Therefore, it is installed when installing ScaLAPACK. ScaLAPACK is a
 parallel version of LAPACK and is used on Beowulf type clusters.

Package: blacs1-pvm
Section: libs
Architecture: any
Depends: pvm, ${shlibs:Depends}, ${misc:Depends}
Description: Basic Linear Algebra Comm. Subprograms - Shared libs. for PVM
 The BLACS project is an ongoing investigation whose purpose is to
 create a linear algebra oriented message passing interface that may be
 implemented efficiently and uniformly across a large range of
 distributed memory platforms.
 .
 You can choose between an implementation based on MPI or PVM. This
 package uses PVM.
 .
 There are packages for the shared libraries (this one), for the
 static libraries and the development files and for test programs.
 .
 Most users do not need to install this package directly because it is
 used as a high level driver for the communication in the ScaLAPACK packages.
 Therefore, it is installed when installing ScaLAPACK. ScaLAPACK is a
 parallel version of LAPACK and is used on Beowulf type clusters.

Package: blacs-pvm-test
Architecture: any
Depends: blacs-test-common, ${shlibs:Depends}, ${misc:Depends}
Description: Basic Linear Algebra Comm. Subprograms - Test files for PVM
 The BLACS project is an ongoing investigation whose purpose is to
 create a linear algebra oriented message passing interface that may be
 implemented efficiently and uniformly across a large range of
 distributed memory platforms.
 .
 You can choose between an implementation based on MPI or PVM. This
 package uses PVM.
 .
 There are packages for the shared libraries, for the static libraries
 and the development files and for test programs (this one).
 .
 Most users do not need to install this package directly because it is
 used as a high level driver for the communication in the ScaLAPACK packages.
 Therefore, it is installed when installing ScaLAPACK. ScaLAPACK is a
 parallel version of LAPACK and is used on Beowulf type clusters.

=== debian/rules ===
#! /usr/bin/make -f
# Made with the aid of debmake, by Christoph Lameter,
# based on the sample debian/rules file for GNU hello by Ian Jackson.
# Handmodified by P. Frauenfelder for debhelper support, 5 Sept 1998

topdir=$(shell pwd)

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp: build-stamp-shared build-stamp-static build-stamp-test $(QUILT_STAMPFN)
	touch build-stamp

build-stamp-shared:
	dh_testdir
	[ -d TESTING/EXE ] || mkdir TESTING/EXE
# clean
	BASEDIR=$(topdir) make cleanall
	cd TESTING && make clean
# build the shared libraries
	BASEDIR=$(topdir) FPIC=-fPIC make pvm
	mkdir -p tmp
	set -e ;\
	cd tmp ;\
	ar x ../LIB/blacs_PVM-LINUX-0.a ;\
	mkdir tmp ;\
	for j in $$(find -name "*.C") ;\
	  do mv $$j tmp/$$(echo $$j | sed 's,C$$,o,g') ;\
	done;\
	cd .. ;\
	gcc -shared -Wl,-soname=libblacs-pvm.so.1 -o libblacs-pvm.so.1.1 \
	  $$(find tmp -name "*.o");\
	ln -sf libblacs-pvm.so.1.1 libblacs-pvm.so.1 ;\
	ln -sf libblacs-pvm.so.1 libblacs-pvm.so ;\
	rm -f tmp/tmp/* ; rmdir tmp/tmp ; rm tmp/* ;\
	rmdir tmp

	touch build-stamp-shared

build-stamp-static:
	dh_testdir
	[ -d TESTING/EXE ] || mkdir TESTING/EXE
# clean
	BASEDIR=$(topdir) make cleanall
	cd TESTING && make clean
# static libaries
	BASEDIR=$(topdir) make pvm

	touch build-stamp-static

build-stamp-test:
	dh_testdir
	[ -d TESTING/EXE ] || mkdir TESTING/EXE
# clean
	BASEDIR=$(topdir) make cleanall
	cd TESTING && make clean
# testing binaries
#	cd TESTING && BASEDIR=$(topdir) BTLIBS='$$(BLACSLIB) $$(PVMLIB)' make
	cd TESTING && BASEDIR=$(topdir) BTLIBS='-L.. -lblacs-pvm $$(PVMLIB)' make

	touch build-stamp-test

clean: unpatch
	dh_testdir
	dh_testroot
	rm -f build-stamp-*
	BASEDIR=$(topdir) make cleanall
	cd LIB && rm -f *.a
	cd TESTING && make clean
	rm -f TESTING/EXE/*
	rm -f SRC/PVM/INTERNAL/Bconfig.h
	rm -f SRC/PVM/INTERNAL/Bdef.h
	rm -f libblacs*so*
	dh_clean

binary-arch: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs -a

	install LIB/blacs_PVM-LINUX-0.a \
		`pwd`/debian/blacs-pvm-dev/usr/lib/libblacs-pvm.a
	install libblacs-pvm.so.1.1 \
		`pwd`/debian/blacs1-pvm/usr/lib/libblacs-pvm.so.1.1
	install TESTING/EXE/xFbtest_PVM-0 \
		`pwd`/debian/blacs-pvm-test/usr/lib/blacs/fblacs_test-pvm
	install TESTING/EXE/xCbtest_PVM-0 \
		`pwd`/debian/blacs-pvm-test/usr/lib/blacs/cblacs_test-pvm

	dh_installdocs -a README
	dh_installman -a
	dh_installchangelogs -a
	dh_link -a
	dh_compress -a 
	dh_fixperms -a
	dh_strip -a
	dh_makeshlibs -V 
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary-indep: build

source diff:
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

binary: binary-indep binary-arch

.PHONY: binary binary-arch binary-indep clean build unpatch
